import React, { useEffect } from "react";
import { Modal, Spin } from "antd";
import { useModalState } from "../../../zustand/Modal";
import FormikForm from "../../../Layout/Dashboard/FormikFormModel";
import ModelBody from "./Add";
import { getInitialValues, getValidationSchema } from "./formUtil";
import { ModalEnum } from "../../../enums/Model";

import { useAddAdmin } from "../../../api/admin";
import { useObjectToEdit } from "../../../zustand/ObjectToEditState";
import { useTranslation } from "react-i18next";

const ModalForm: React.FC = () => {
  const { isOpen, setIsOpen } = useModalState((state) => state);
  const { mutate, isSuccess, isLoading } = useAddAdmin();
  const { set_object_to_edit } = useObjectToEdit();
  useEffect(() => {
    if (isSuccess) {
      setIsOpen("isSuccess");
      set_object_to_edit({});
    }
  }, [setIsOpen, isSuccess]);

  const handleSubmit = (values: any) => {
    console.table(values);

    const branches = values?.selects
      ?.map((item: any) => {
        return {
          branch_id: item?.branch,
          role_id: item?.role,
        };
      })
      .filter((item: any) => item.branch_id !== null && item.role_id !== null);

    const dataToSend = { ...values };
    if (values?.status === true) {
      dataToSend["status"] = "active";
    }
    if (values?.status === false) {
      dataToSend["status"] = "suspend";
    }
    if (branches?.length > 0) {
      dataToSend["branches"] = branches;
    }
    mutate({
      ...dataToSend,
    });
  };

  const handleCancel = () => {
    setIsOpen("");
    set_object_to_edit({});
  };

  const [t] = useTranslation();
  return (
    <>
      <Modal
        className="ModalForm"
        centered
        width={"60vw"}
        footer={null}
        open={isOpen === ModalEnum?.ADMIN_ADD}
        onCancel={handleCancel}
      >
        <FormikForm
          handleSubmit={handleSubmit}
          initialValues={getInitialValues([])}
          validationSchema={getValidationSchema}
        >
          <header>
            {t("practical.add")} {t("models.admin")}{" "}
          </header>
          <main className="main_modal w-100">
            <ModelBody />
            <div className="buttons">
              <div onClick={handleCancel}>{t("practical.back")}</div>
              <button disabled={isLoading} type="submit">
                {t("practical.add")}
                {isLoading && (
                  <span className="Spinier_Div">
                    <Spin />
                  </span>
                )}
              </button>
            </div>
          </main>
        </FormikForm>
      </Modal>
    </>
  );
};

export default ModalForm;
